/**************************************************************************
* Xtrophy ICQ - Originally written by tnc (xtrophy@it.dk)                 *
*'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''*
* config.cc                                                               *
* Handle the config files and such..                                      *
**************************************************************************/

#include "main.h"
#include <string.h>

struct USER_CONFIGURATION user_cfg;
FILE *cfgf;

/*
**
** Sets the options for the user
*/
void userConfigure(struct USER_CONFIGURATION *user_cfg)
{
    char *string;
    char config_file[BUFSIZE];

    user_cfg->uin		= 0;
    if (user_cfg->password != NULL) free(user_cfg->password);
    user_cfg->password= NULL;
    if (user_cfg->nick != NULL) free(user_cfg->nick);
    user_cfg->nick = NULL;
    if (user_cfg->firstName != NULL) free(user_cfg->firstName);
    user_cfg->firstName = NULL;
    if (user_cfg->lastName != NULL) free(user_cfg->lastName);
    user_cfg->lastName = NULL;
    if (user_cfg->email != NULL) free(user_cfg->email);
    user_cfg->email = NULL;
    if (user_cfg->logfile != NULL) free(user_cfg->logfile);
    user_cfg->logfile = NULL;
    user_cfg->defaultStatus= 0;
    if (user_cfg->contactList != NULL) free(user_cfg->contactList);
    user_cfg->contactList = NULL;
    if (user_cfg->serverAddr != NULL) free(user_cfg->serverAddr);
    user_cfg->serverAddr = NULL;
    user_cfg->serverPort = 0;
    user_cfg->clientPort = 0;
   
    sprintf(config_file, "SYS$LOGIN:%s", CONFIG_FILE);

    if(DEBUG)
	    printf("Config: %s\n",config_file);

    string = (char *) malloc(BUFSIZE);
    cfgf=fopen(config_file,"r");
    if (!cfgf) {
        MY_PRINTF(color.none, "Couldn't open %s.\n", config_file);
	free(string);
        exit(1);
    } else {
        while(fgets(string, BUFSIZE,cfgf)) {
            if (!(strlen(string) == 1 && string[0] == '\n') &&
                  strlen(string) != 0)
            {
                if (string[0] != '#')
                {
                    char *tmp, *tmp2;

                    tmp = strtok(string, "=");
                    if (!strcmp(tmp, "UIN"))
                    {
                        user_cfg->uin = atoi(strtok(NULL, ""));
                    }
                    else if (!strcmp(tmp, "PASSWORD"))
                    {
                        tmp2=strtok(NULL,"\n");
                        user_cfg->password=(char *)malloc(strlen(tmp2)+1);
                        /*if user_cfg->password==0 the error*/
                        sprintf(user_cfg->password, "%s", tmp2);
                    }
                    else if (!strcmp(tmp, "NICK"))
                    {
                        tmp2=strtok(NULL,"\n");
                        user_cfg->nick=(char *)malloc(strlen(tmp2)+1);
                        /*if user_cfg->password==0 the error*/ 
                        sprintf(user_cfg->nick, "%s", tmp2);
                    }
                    else if (!strcmp(tmp, "FIRSTNAME"))
                    {
                        tmp2=strtok(NULL,"\n");
                        user_cfg->firstName=(char *)malloc(strlen(tmp2)+1);
                        /*if user_cfg->password==0 the error*/
                        sprintf(user_cfg->firstName, "%s", tmp2);
                    }
                    else if (!strcmp(tmp, "LASTNAME"))
                    {
                        tmp2=strtok(NULL,"\n");
                        user_cfg->lastName=(char *)malloc(strlen(tmp2)+1);
                        /*if user_cfg->password==0 the error*/
                        sprintf(user_cfg->lastName, "%s", tmp2);
                    }
                    else if (!strcmp(tmp, "EMAIL"))
                    {
                        tmp2=strtok(NULL,"\n");
                        user_cfg->email=(char *)malloc(strlen(tmp2)+1);
                        /*if user_cfg->password==0 the error*/
                        sprintf(user_cfg->email, "%s", tmp2);
                    }
                    else if (!strcmp(tmp, "ICQSERVER"))
                    {
                        tmp2=strtok(NULL,"\n");
                        user_cfg->serverAddr=(char *)malloc(strlen(tmp2)+1);
                        /*if user_cfg->password==0 the error*/
                        sprintf(user_cfg->serverAddr, "%s", tmp2);
                    }
                    else if (!strcmp(tmp, "LOGFILE"))
                    {
                        tmp2=strtok(NULL,"\n");
                        user_cfg->logfile=(char *)malloc(strlen("sys$login:")+strlen(tmp2)+1);
                        /*if user_cfg->password==0 the error*/
                        sprintf(user_cfg->logfile, "sys$login:%s", tmp2);
			if(DEBUG) printf("Logfile: %s\n",user_cfg->logfile);
                    } 
                    else if (!strcmp(tmp, "CONTACT_FILE"))
                    {
                        tmp2=strtok(NULL,"\n");
                        user_cfg->contactList=(char *)malloc(strlen("sys$login:")+strlen(tmp2)+1);  
                        /*if user_cfg->password==0 the error*/
                        sprintf(user_cfg->contactList, "sys$login:%s", tmp2);
			if(DEBUG) printf("Contact: %s\n",user_cfg->contactList);
                    }
                    else if (!strcmp(tmp, "ICQPORT"))
                    {
                        user_cfg->serverPort = atoi(strtok(NULL, ""));
                    }
                    else if (!strcmp(tmp, "STATUS"))
                    {
			user_cfg->status = atoi(strtok(NULL, ""));
                    }
                    else if (!strcmp(tmp, "SHOWOFFLINE"))
                    {
                        tmp = strtok(NULL, "");

                        tmp[0] = toupper(tmp[0]);
                        if (tmp[0] == '1' || tmp[0] == 'T' || tmp[0] == 'Y')
                            user_cfg->showoffline = 1;
                        else
                            user_cfg->showoffline = 0;
                    }
                    else if (!strcmp(tmp, "COL_TITLEB"))
                    {
                        sprintf(color.titleB, "%c[%sm", '\033', strtok(NULL, ""));
                    }
                    else if (!strcmp(tmp, "COL_TITLED"))
                    {
                        sprintf(color.titleD, "%c[%sm", '\033', strtok(NULL, ""));
                    }
                    else if (!strcmp(tmp, "COL_BORDER"))
                    {
                        sprintf(color.border, "%c[%sm", '\033', strtok(NULL, ""));
                    }
                    else if (!strcmp(tmp, "COL_HEADER"))
                    {
                        sprintf(color.header, "%c[%sm", '\033', strtok(NULL, ""));
                    }
                    else if (!strcmp(tmp, "COL_TEXT"))
                    {
                        sprintf(color.text, "%c[%sm", '\033', strtok(NULL, ""));
                    }
                    else if (!strcmp(tmp, "COL_NONE"))
                    {
                        sprintf(color.none, "%c[%sm", '\033', strtok(NULL, ""));
                    }
                }
            }
        }
        fclose(cfgf);
	free (string);
    }
}
